﻿using System;
using System.IO;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.iOS;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;
using UIKit;

namespace OSMSample
{
    public partial class ViewController : UIViewController
    {
        public ViewController(IntPtr handle) : base(handle)
        {
        }

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            MapView mapView = new MapView(View.Frame);
            View.Add(mapView);

            mapView.MapUnit = GeographyUnit.Meter;
            //mapView.ZoomLevelSet = new OpenStreetMapsZoomLevelSet();
            mapView.ZoomLevelSet = new ZoomLevelSet();
            double scaleFactor = 1.77637294665598;
            double InitialMapScale = 7340814.88188305;
            mapView.MinimumScale = 75;
            for (int i = 0; i < 20; i++)
            {
                double resolution = InitialMapScale / Math.Pow(scaleFactor, i);
                mapView.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(resolution));
            }
            mapView.CurrentExtent = new RectangleShape(-11892124.6458261, 4399535.77631164, -10381093.8618732, 2978914.08249627);

            LayerOverlay OSMOverlay = new LayerOverlay();
            OSMOverlay.DrawingExceptionMode = DrawingExceptionMode.DrawException;
            OpenStreetMapLayer osml = new OpenStreetMapLayer();
            osml.ZoomlevelSet = new OpenStreetMapsZoomLevelSet();
            osml.DrawingExceptionMode = DrawingExceptionMode.DrawException;
            OSMOverlay.Layers.Add(osml);

            mapView.Overlays.Add(OSMOverlay);
            mapView.Refresh();
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
            // Release any cached data, images, etc that aren't in use.
        }
    }
}